package checkAlign;


public class IllegalChars {
	private String matrix;
	boolean hasIllegalChars = false;
	
	public IllegalChars(){}
	public void setMatrix(String input){
		matrix = input.trim();
	}	
	boolean searchIllegalChars(){    	
    	char[] protein = {'D','E','F','H','I','K','L','M','N','P','Q','R','S','V','W','Y'};
    	char[] dna = {'A','C','G','T'};
    	char[] total = {'A','C','D','E','F','G','H','I','K','L','M','N','P','Q','R','S','T','V','W','Y','-'};
    	boolean isProtein = false;
    	boolean found = false;
    	int countProtein = 0;
    	int countDna = 0;
    	double percentProtein = 0;
    	double percentDna = 0;
    	int alignLength = matrix.length();
    	
    	// detect protein
    	for (int i=0; i<alignLength; i++){
    		for (int j=0; j<protein.length; j++){
    			if (matrix.charAt(i) == protein[j]){
    				countProtein ++;
    			}
    		}
    	}
    	// detect dna
    	for (int i=0; i<alignLength; i++){
    		for (int j=0; j<dna.length; j++){
    			if (matrix.charAt(i) == dna[j]){
    				countDna ++;
    			}
    		}
    	}
    	
    	// calculate percent of type to determine type of alignment    	
    	percentProtein = (double)countProtein / (double)alignLength;
    	percentDna = (double)countDna / (double)alignLength;
    	
    	if (percentProtein > percentDna){
    		isProtein = true;
    	}
    	
    	// if it dna verify if there are illegal letters present
    	if (!isProtein){    		
    		for (int i=0; i<alignLength && !hasIllegalChars; i++){
    			found = false;
    			for (int j=0; j<dna.length && !hasIllegalChars && !found; j++){
    				if (matrix.charAt(i) == dna[j] || matrix.charAt(i) == '-' || matrix.charAt(i) == '\n'  || matrix.charAt(i) == '\r'){
    					found = true;
    				}
    			}
    			if (!found){
    				return true;
    			}
    		}
    	}
    	return false;
	}
}
